package POWER::Event::IO::CRYPT::RC4;

use version; $VERSION = qv('0.0.1');    # update POD & Changes & README

use warnings;
use strict;
use Carp;

use Crypt::RC4;

use base qw( POWER::Event::IO::plugin );
use POWER::Event::IO::share;


sub new {
    my ($class, $opt_ref) = @_;
    croak '{cipher} required' if !defined $opt_ref->{cipher};
    my $self = $class->SUPER::new($opt_ref);
    $self->{rcrypt} = Crypt::RC4->new($opt_ref->{cipher});
    $self->{wcrypt} = Crypt::RC4->new($opt_ref->{cipher});
    return $self;
}

sub READ {
    my ($self, $io) = @_;
    $self->{in_buf}     = q{};
    $self->{in_bytes}   = 0;
    $self->_real_read($io);
    $_[2] .= $self->{rcrypt}->RC4($self->{in_buf});
    return $self->{in_bytes};
}

sub WRITE {
    my ($self, $io, undef, $out_pos) = @_;
    my $s = substr($_[2], $out_pos);
    my $n = length $s;
    $self->{out_buf} .= $self->{wcrypt}->RC4($s);
    $self->{out_bytes}  = 0;
    $self->_real_write($io);
    return $n;
}
        
1; # Magic true value required at end of module
__END__

