package POWER::Event::IO::UDP;
use POWER::Event::IO::share;
use base qw( POWER::Event::IO );

use version; $VERSION = qv('0.2.0');    # update POD & Changes & README

use warnings;
use strict;
use Carp;

use Socket;


$Class{'POWER::Event::IO::UDP'} = {
    event       => $ERR|$IN|$OUT,
    style       => $PACKET_IO,
    socktype    => $SOCK_DGRAM,
    sockproto   => $PROTO_UDP,
};


#   -   TODO   UDP:
#
#  $UDP      recv/send.   ?
#
# ݣ -   out_host/out_ip  out_port  
#  out_paddr.   out_host   ,
#     -   ( 
# ӣ- , ).
#
#  ݣ    in_paddr  in_ip  in_port.
# , -,     ,    
# .
#
# ,   UDP-,    bind_host 
# bind_port.         $UDP - 
# bind_host  bind_ip   bind()   .

sub _real_config {
    die q{don't know what to do with resolved IP for UDP};
}

sub _real_read {
    my ($self) = @_;
    return if defined $self->{in_buf};
    #   ,  UDP   65507 
    #  -  EMSGSIZE.
    #        
    #   (DNS-   512 ), 
    #        .
    # WARNING   perl   {in_buf}  64KB,    .
    #             - UDP- ģ  !
    $self->{in_paddr} = recv $self->{fh}, $self->{in_buf}, 0xFFFF, 0;
    if (defined $self->{in_paddr}) {
        $self->{in_bytes}  += length($self->{in_buf});
        $self->{_events}   |= $IN;
    }
    elsif ($! != $EAGAIN) {
        $self->{_err}       = $!;
        $self->{_events}   |= $ERR;
    }
    return;
}

sub _real_write {
    my ($self) = @_;
    return if !defined $self->{out_buf};
    my $n = send $self->{fh}, $self->{out_buf}, 0, $self->{out_paddr};
    if (defined $n) {
        #   ,  out_buf    , 
        #       EMSGSIZE.
        $self->{out_buf}    = undef;
        $self->{out_bytes} += $n;
        $self->{_events}   |= $OUT;
    }
    elsif ($! != $EAGAIN) { #      UDP EAGAIN?
        $self->{_err}       = $!;
        $self->{_events}   |= $ERR;
    }
    return;
}


1; # Magic true value required at end of module
__END__

=head1 DESCRIPTION

See L<POWER::Event::IO>.
