use Test::More;
use Test::Exception;
use Test::MockModule;

use Module::Build;
use vars qw( $Build );
$Build = Module::Build->current;

use POSIX qw(locale_h);
setlocale(LC_ALL, 'C');

use POWER::Event;
use POWER::Event::IO;

use POWER::Utils::IO;

### Usage example:
#@CheckPoint = (
#    [ 'listener',   $ACCEPTED       ], 'accept incoming connection',
#    [ 'ssl_client', $IN             ], 'client: got server banner',
#    [ 'ssl_client', $banner         ], 'client: banner is correct',
#    [ 'ssl_client', $SENT           ], 'client: request sent',
#    [ 'ssl_server', $EOF            ], 'server: got eof',
#    [ 'ssl_server', $msg            ], 'server: requst is correct',
#    [ 'ssl_server', $SENT           ], 'server: reply sent',
#    [ 'ssl_client', $EOF            ], 'client: got eof',
#    [ 'ssl_client', "echo: $msg"    ], 'client: reply is correct',
#);
#plan tests => @CheckPoint/2;
use vars qw( @CheckPoint );
sub checkpoint {
    my ($func) = (caller(1))[3]=~/.*::(.*)/;
    is_deeply([$func, @_], shift @CheckPoint, shift @CheckPoint);
    return;
}

### Usage example:
#sub ssl_client {
#    my ($io) = @_;
#  &diag_event;
#}
sub diag_event {
    my ($io) = @_;
    my ($func) = (caller(1))[3]=~/.*::(.*)/;
    diag "$func :"
      . ($io->{events} & $RESOLVED  ? ' RESOLVED'       : '')
      . ($io->{events} & $ACCEPTED  ? ' ACCEPTED'       : '')
      . ($io->{events} & $CONNECTED ? ' CONNECTED'      : '')
      . ($io->{events} & $IN        ? ' IN'             : '')
      . ($io->{events} & $EOF       ? ' EOF'            : '')
      . ($io->{events} & $OUT       ? ' OUT'            : '')
      . ($io->{events} & $SENT      ? ' SENT'           : '')
      . ($io->{events} & $ERR       ? " ERR=$io->{err}" : '')
      ;
}

1;
