use warnings;
use strict;
use Test::More tests => 1;
use Test::Exception;
use Test::MockModule;

use Socket;


my $pid = fork();

use vars qw( $ERR $RESOLVED $CONNECTED $ACCEPTED $IN $OUT $EOF $SENT $EINBUFLIMIT );
eval '
use POWER::Event;
use POWER::Event::IO;
';

pipe my $rd, my $wr or die "pipe: $!";

if (!$pid) {
    close $rd;
    close $wr;
    # ,  ģ  "Internal error: no I/O object for ...".
    eval { loop() };
    diag $@;
    exit 255;
}

#  $rd  epoll.
POWER::Event::IO->new({
    fh          => $rd,
    cb          => sub {},
    wait_for    => $EOF,
    in_buf_limit=> 1024,
});
#  epoll-  $rd.
print {$wr} "test";
close $wr;
#  child  .
sleep 1;
kill KILL => $pid;
wait;
is($?, 9, 'child exit status');

